﻿using Prism.Ioc;
using Prism.Modularity;
using Prism.Regions;
using StartServerWPF.Modules.Main.ViewModels;
using StartServerWPF.Modules.Main.Views;

namespace StartServerWPF.Modules.Main
{
    public class MainModule : IModule
    {
        public void OnInitialized(IContainerProvider containerProvider)
        {
           var  iRegion=  containerProvider.Resolve<IRegionManager>();
            iRegion.RegisterViewWithRegion("MainContentRegion", typeof(MainView));
        }

        public void RegisterTypes(IContainerRegistry containerRegistry)
        {
            containerRegistry.RegisterDialog<SetParamDialog>();
        }
    }
}