﻿using Prism.Mvvm;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace StartServerWPF.Modules.Main.Model
{
    /// <summary>
    /// VPN信息类
    /// </summary>
    public class VpnInfo : BindableBase
    {
        private string vpnName;
        private string vpnIP;
        private string vpnUserName;
        private string vpnPsw;
        private string systemLogPath;
        private string dataSavePath;

        /// <summary>
        /// VPN名称
        /// </summary>
        public string VpnName { get => vpnName; set => SetProperty(ref vpnName, value); }
        /// <summary>
        /// VPNIP
        /// </summary>
        public string VpnIP { get => vpnIP; set => SetProperty(ref vpnIP, value); }
        /// <summary>
        /// VPN用户名
        /// </summary>
        public string VpnUserName { get => vpnUserName; set => SetProperty(ref vpnUserName, value); }
        /// <summary>
        /// VPN密码
        /// </summary>
        public string VpnPsw { get => vpnPsw; set => SetProperty(ref vpnPsw, value); }

        /// <summary>
        /// 系统日志路径
        /// </summary>
        public string SystemLogPath { get => systemLogPath; set => SetProperty(ref systemLogPath, value); }
        /// <summary>
        /// 数据存储路径
        /// </summary>
        public string DataSavePath { get => dataSavePath; set => SetProperty(ref dataSavePath, value); }
    }
}
